%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 3
%global version_micro 16
%global version_release None
%global commitid b6784b0dfae7468f522c52f434aab305b6cb643f
%global serial 7
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%{?scl:%scl_package mod_cluster-native}
%{!?scl:%global pkg_name %{name}}

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

%define reltag .Final
%define namedversion %{version}%{reltag}
%define jarname mod-cluster

# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root

%define with_zip 1
%bcond_with zip

Name:		%{?scl_prefix}mod_cluster-native
Summary: 	JBoss mod_cluster for Apache httpd
Version: 	1.3.16
Release: 	%{serial}%{reltag}_redhat_2%{?dist}
Epoch:		0
License: 	LGPLv3
Group: 		Applications/System
URL:		http://www.jboss.org/
Source0:        mod_cluster-%{commitid}.tar.gz
Source1:        %{pkg_name}.conf
Source2:        %{pkg_name}.te
Source3:        %{pkg_name}.fc

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	%{?scl_prefix}httpd-devel
BuildRequires:	%{?scl_prefix}apr-devel
BuildRequires:	%{?scl_prefix}apr-util-devel
%if "%{?rhel}" >= "7"
#64 bit natives only on RHEL 7
ExcludeArch:   i686 i386
%endif
BuildRequires:	autoconf
BuildRequires:	zip
#For SELinux
%if "%{?rhel}" == "6"
BuildRequires: selinux-policy
%else
####%%%%{_datadir}/selinux/devel/Makefile is in -devel on RHEL 5 and RHEL 7
BuildRequires: selinux-policy-devel
%endif

%if "%{?rhel}" <= "7"
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python
%else
Requires(post): python3-policycoreutils
Requires(postun): python3-policycoreutils
%endif

Requires:   %{?scl_prefix}httpd >= 0:2.4.6
Requires:   %{?scl_prefix}apr
Requires:   %{?scl_prefix}apr-util

%description
JBoss mod_cluster for Apache httpd 2.4.6.

%if %with zip
%package src-zip
Summary:     Container for the source distribution of %{pkg_name}
Group:       Development

%description src-zip
Container for the source distribution of %{pkg_name}.
%endif

%prep
%setup -q -n mod_cluster-%{commitid}

%build
zip -q -r ../%{name}-%{namedversion}-src.zip native/*

%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)

pushd native
for i in advertise mod_manager mod_proxy_cluster mod_cluster_slotmem
do
pushd $i
%{?scl:scl enable %scl - << \EOF}
set -e
sh buildconf
./configure --with-apxs="%{apxs}"
make CFLAGS="%{optflags} -fno-strict-aliasing -DMOD_CLUSTER_RELEASE_VERSION=\\\"-%{serial}\\\""
%{?scl:EOF}
popd
done
popd

%install
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{pkg_name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT/%{aplibdir}/
cp -p native/*/*.so ${RPM_BUILD_ROOT}/%{aplibdir}/
install -d -m 755 $RPM_BUILD_ROOT/%{_localstatedir}/cache/mod_cluster

install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
install -p -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_cluster.conf

# JBCS-167
sed -i -e 's@/var/cache/mod_cluster@%{scldir}/var/cache/mod_cluster@g' \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_cluster.conf

%if %with zip
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
install -p -m 644 ../%{name}-%{namedversion}-src.zip \
        $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

# for SELinux
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}
mkdir selinux
pushd selinux
    cp -p %{SOURCE2} .
    cp -p %{SOURCE3} .

    make -f %{_root_datadir}/selinux/devel/Makefile
    install -p -m 644 -D %{pkg_name}.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}/mod_cluster.pp
popd

%clean
rm -Rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then
    %{_root_sbindir}/semodule -i %{_datadir}/selinux/packages/%{name}/mod_cluster.pp 2>/dev/null || :
    %{_root_sbindir}/semanage port -a -t http_port_t -p udp 23364 >/dev/null 2>&1 || :
    %{_root_sbindir}/semanage port -a -t http_port_t -p tcp 6666 >/dev/null 2>&1 || :
    /sbin/restorecon -R %{scldir}/var/cache/mod_cluster >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    %{_root_sbindir}/semanage port -d -t http_port_t -p udp 23364 2>&1 || :
    %{_root_sbindir}/semanage port -d -t http_port_t -p tcp 6666 2>&1 || :
    %{_root_sbindir}/semodule -r mod_cluster >/dev/null 2>&1 || :
    /sbin/restorecon -R %{scldir}/var/cache/mod_cluster >/dev/null 2>&1 || :
fi

%files
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%defattr(0644,root,root,0755)
%doc lgpl.txt
%dir %{_localstatedir}/cache/mod_cluster
%attr(0755,root,root) %{aplibdir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_cluster.conf
# for SELinux
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/mod_cluster.pp

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Mon Sep 27 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-7
Built by CPaaS

* Thu Sep 16 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-6
Built by CPaaS

* Fri Jun 11 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-5
Built by CPaaS

* Wed Jun 02 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-4
Built by CPaaS

* Fri May 07 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-3
Built by CPaaS

* Thu May 06 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-2
Built by CPaaS

* Thu May 06 2021 cpaas-ops <cpaas-ops@redhat.com> - 1.3.16-1
Built by CPaaS

* Thu Apr 08 2021 Sokratis Zappis <szappis@redhat.com> - 1.3.14-20
- Rebuild for SP7

* Tue May 05 2020 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.14-1
- Upgrading to mod_cluster 1.3.14 [JBCS-941]

* Tue Mar 17 2020 George Zaronikas <gzaronik@redhat.com> - 1.3.12-39
MODCLUSTER-714

* Fri Oct 11 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-9
-  Rebuilding JBCS httpd 2.4.37-ER5

* Thu Oct 10 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-8
- JBCS httpd 2.4.37-ER5

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-7
- Building JCBS 2.4.37.ER4

* Mon Sep 23 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-6
- JBCS 2.4.37.ER3

* Thu Aug 29 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-4
- Enabled src zip in both dists

* Thu Aug 29 2019 Hui Wang <huwang@redhat.com> - 1.3.12-3
- Enable src-zip for rhel7

* Tue Aug 27 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.12-2
- Test build

* Wed Aug 21 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.12-1
- Updating to mod_cluster 1.3.12 [JBCS-803]

* Tue Aug 06 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-10
- JBCS 2.4.37.ER2

* Wed Jul 24 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-6
- JBCS 2.4.37.ER1

* Fri Jul 19 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.3.11-5
- JBCS 2.4.37.ER1

* Thu Jun 27 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.11-2
- Applied fix for [JBCS-405]

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 1.3.11-2
- Build with new httpd 2.4.37

* Wed Jun 19 2019 Hui Wang <huwang@redhat.com> - 1.3.11-1
- Build with new httpd 2.4.37

* Wed Jun 05 2019 Petros Marios Prokopiou <pprokopi@redhat.com> - 1.3.11-1
- Updating to mod_cluster 1.3.11 [JBCS-446]

* Thu Nov 01 2018 Sokratis Zappis <szappis@redhat.com> - 1.3.8-3
- Build for JBCS httpd 2.4.29 SP1 DR1

* Tue Mar 06 2018 Hui Wang <huwang@redhat.com> - 1.3.8-1
- Build with the latest commitId

* Tue Mar 06 2018 Jean-Frederic Clere <jclere@redhat.com> - 1.3.8-1
- retrying...

* Mon Mar 05 2018 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.3.8-1
- Build with httpd 2.4.29

* Mon Mar 05 2018 Jean-Frederic Clere <jclere@redhat.com> - 1.3.8-1
- Adjust to the new git repo.

* Tue Nov 07 2017 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 1.3.8-14
- Updating to 1.3.8

* Tue Nov 07 2017 George Zaronikas <gzaronik@redhat.com> - 1.3.8-1
- Updating to mod_cluster 1.3.8

* Tue Feb 07 2017 Jan Fnukal <hfnukal@redhat.com> - 1.3.5-14
- jbcs-httpd24 SP1

* Wed Oct 26 2016 Hui Wang <huwang@redhat.com> - 1.3.5-13
- Rebuild

* Wed Oct 26 2016 Jean-Frederic Clere <jclere@redhat.com> - 1.3.5-12
-

* Wed Oct 26 2016 Jean-Frederic Clere <jfclere@redhat.com> - 1.3.5-0
- 1.3.5.Final-redhat

* Fri Oct 21 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.4-12
- 1.3.4.Final-redhat-1

* Wed Sep 28 2016 Coty Sutherland <csutherl@redhat.com> - 1.3.3-12
- Resolves: JBCS-167 mod_cluster-native uses /var/cache/mod_cluster instead of /opt/rh/jbcs-httpd24/root/var/cache/mod_cluster
- Resolves: JBCS-172 Update mod_cluster-native selinux policy

* Wed Jul 20 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.3-11
- 1.3.3.Final-redhat-1

* Wed Jul 20 2016 Permaine Cheung <pcheung@redhat.com> - 1.3.3-1.Final-redhat-1
- 1.3.3

* Tue Feb 16 2016 Fernando Nasser <fnasser@redhat.com> - 1.3.1-10
- Build from source-repos

* Fri Feb 12 2016 Fernando Nasser <fnasser@redhat.com> - 1.3.1-9
- JCSP-24 postun scriptlet fails when unistalling mod_cluster-native

* Tue Dec 22 2015 Fernando Nasser <fnasser@redhat.com> - 0:1.3.1-7
- Build in the jbcs-httpd24 collection

* Tue Oct 20 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-6.Final-redhat-2
- Rebuild

* Fri Apr 10 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-5.Final-redhat-2
- 1.3.1.Final-redhat-2
- Remove patch for CVE-2015-0298 as it has been incorporated in the new tag

* Wed Mar 18 2015 Dustin Kut Moy Cheung <dcheung@redhat.com> - 0:1.3.1-4.Beta2-redhat-1
- add patch for CVE-2015-0298

* Mon Jan 26 2015 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-3.Beta1-redhat-1
- 1.3.1.Beta2-redhat-1

* Thu Dec 18 2014 Weinan Li <weli@redhat.com> - 0:1.3.1-2.Beta1
- Fix conf file

* Tue Nov 18 2014 Permaine Cheung <pcheung@redhat.com> - 0:1.3.1-1.Beta1
- 1.3.1.Beta1
- JWS 3.0 build
